/*===========================================
			Wii Paint 1.0
	Ejemplo de las librerias
	GRRlib 2.0 por Kontakatilu
===========================================*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include <ogcsys.h>
#include <gccore.h>
#include "wiiuse.h"

//Aqui se inculyen los archivos de imagen previamente convertidos con el GRRLIB GFX Converter
#include "../gfx/letras.h" //texto del principio un poco feo la verdad
#include "../gfx/fondo.h"
#include "../gfx/mano.h"


#include "GRRLIB.h"
extern u16 *GRRLIB_buffer;
extern u16 *GRRLIB_bufferdos;
#define MAX_WIIMOTES				4
unsigned int irx=0,iry=0;//Variables de las cordenadas de los infrarojos
unsigned int buttonB=0;//variable del boton B
unsigned int buttonA=0;//variable del boton A
int i;

void (*reload)() = (void (*) ()) 0x80001800;//Funcion para reiniciar el Loader
//Aqui monitoriza los botones del wiimote
void wiimote_event(struct wiimote_t* wm, int event) {
	
	switch (event) {
		case WIIUSE_EVENT:
		
			buttonB=0;//variables a cero
			//buttonA=0;//variables a cero
			
			//if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_ONE)){
			//wiiuse_set_ir(wm, 1);
			//usleep(200000);
			//wiiuse_motion_sensing(wm, 0);
			//usleep(200000);
			//}
			
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_B))//Asigna 1 a la variable Boton B cuando se pulsa
				buttonB=1;
			if (IS_RELEASED(wm, WIIMOTE_BUTTON_A))//Cuando sueltas el boton A la variable cambia a 0
				buttonA=0;
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_A)) //Asigna 1 a la variable Boton A
				buttonA=1;
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_UP))// esto es para la sincronizacion con el wiimote
				wiiuse_set_ir(wm, 1);
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_DOWN))// esto es para la sincronizacion con el wiimote
				wiiuse_set_ir(wm, 0);
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_LEFT))// esto es para la sincronizacion con el wiimote
				
				wiiuse_motion_sensing(wm, 0);
			
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_RIGHT))// esto es para la sincronizacion con el wiimote
				wiiuse_motion_sensing(wm, 1);
					irx=(unsigned)wm->ir.dot[0].x;
					iry=(unsigned)wm->ir.dot[0].y;
					
			break;
	}
}

//Modulo principal

int main(){
u16 colore;//variable donde almacena el color del lapiz
colore=0x2bf;//damos un valor al color, el azul
//declaramos las coordenadas iniciales
int xold;
int yold;
//les damos un valor simbolico para que el compilador no de error
xold=0;
yold=0;
    wiimote** wiimotes;
//Inicia el video
	GRRLIB_buffer=(u16 *)malloc(640*480*2);	
	GRRLIB_bufferdos=(u16 *)malloc(640*480*2);
	VIDEO_Init();
	PAD_Init();//Inicia los controles creo...

	GRRLIB_InitVideo();
	GRRLIB_Start();
//Borra la pantalla y espera a sincronizacion con el wiimote
	GRRLIB_FillScreen(0x0000);//Pone negra la pantalla
	
//Presenta el mensaje de sincronizacion del wiimote, muy mono ahora que le he cambiado la letra jeje...
	GRRLIB_Print(15,50+35*3,32,32,"     PORFAVOR",letras_img);
	GRRLIB_Print(15,50+35*4,32,32,"    PULSA 1 Y 2",letras_img);
	GRRLIB_Print(15,50+35*5,32,32,"   EN TU WIIMOTE",letras_img);
	GRRLIB_Render();//Renderiza
	VIDEO_WaitVSync();

	*((u32*)0xcd0000c0) |= 0x100;
//Esto es lo que debe de sincronizar tu wiimote
	bte_init();
	bte_start();
	wiimotes =  wiiuse_init(MAX_WIIMOTES, wiimote_event);
	wiiuse_find(wiimotes, MAX_WIIMOTES, 5);
	wiiuse_connect(wiimotes, MAX_WIIMOTES);
	wiiuse_set_leds(wiimotes[0], WIIMOTE_LED_1);//Enchufa el Led 1 del wiimote
	wiiuse_rumble(wiimotes[0], 1);//Enchufa el vibrador
	usleep(200000); //Hace una pausa de 200ms 
	wiiuse_rumble(wiimotes[0], 0);//Apaga el vibrador
	wiiuse_set_ir(wiimotes[0], 0);
	usleep(200000); //Hace una pausa de 200ms 
	wiiuse_motion_sensing(wiimotes[0], 1);
	GRRLIB_FillScreen(0x0000);//Pone negra la pantalla principal
	GRRLIB_FillScreendos(0x0000);//Ponemos negra la pantalla de fondo
	GRRLIB_DrawImgdos(0,0,fondo_width,fondo_high,fondo_img,0,1);//Dibujamos el fondo del programa en la pantalla de abajo
	
	while(1){//Se repite hasta el fin del programa
		GRRLIB_FillScreen(0x0000);//Pone negra la pantalla principal
		int ex;for(ex=0;ex<640*480;ex++) GRRLIB_buffer[ex]=GRRLIB_bufferdos[ex];//copiamos el buffer de la pantalla de fondo en la principal
  		GRRLIB_DrawImg(irx-13,iry,mano_width,mano_high,mano_img,0,1);//Dibuja nuestra querida mano
		if(buttonB==1) reload ();//Si se pulsa el boton B se reiinicia el loader
		if(buttonA==1){//Si se pulsa el boton A pinta
		if(irx-1>83){//Comprueba si estamos sobre la paleta de colores y si no lo estamos dibuja
			//Esta era la rutina que tenia antes para pintar pero solo pintaba puntos y si te movias muy rapido quedaban desperdigaos asi que no la cambie por la siguiente
			//GRRLIB_PutPixeldos(irx-1,iry-1,color);GRRLIB_PutPixeldos(irx-1,iry,color);	GRRLIB_PutPixeldos(irx-1,iry+1,color);
			//GRRLIB_PutPixeldos(irx,iry-1,color);GRRLIB_PutPixeldos(irx,iry,color);	GRRLIB_PutPixeldos(irx,iry+1,color);
			//GRRLIB_PutPixeldos(irx+1,iry-1,color);GRRLIB_PutPixeldos(irx+1,iry,color);GRRLIB_PutPixeldos(irx+1,iry+1,color);
			GRRLIB_Linedos(xold,yold,irx,iry,colore);//Dibuja una linea entre el punto anterior y el actual
			}
			else//Si estamos sobre la paleta de colores absorvemos el color
			{
			colore=GRRLIB_bufferdos[iry*640+(irx)];//asignamos el color de la pantalla de fondo al lapiz
			}
		}
		xold=irx;yold=iry;//Almacenamos las coordenadas actuales para la siguiente linea
		GRRLIB_Render();//Renderiza
		VIDEO_WaitVSync();
	}

return(0);

}
